/* 
 * CSE142, 99 Winter
 * Homework 5
 * Valentine's Day
 *
 * Author:     Ace Atienza
 * Student ID: 9820931
 * Section:    AI
 */

#include "gp142.h"
#include <math.h>
#include <time.h>
	/* <time.h> is here only so that one function can be called
	to seed the random number generator.
	Put it here in your program and forget about it, 
	just in case you decide later you need to use random numbers.
	*/

#define TRUE    		1
#define FALSE   		0

// The state, or status you are in determines what happens when you click the card
#define STATUS_ADD_SHAPE 1		// add shape
#define STATUS_SELECTED 2		// do something to selected object
#define STATUS_ADD_MESSAGE 3	// add message
#define STATUS_SELECT_OBJECT 4	// click object to select it

// Button attributes
#define BUTTON_HEIGHT  	35
#define BUTTON_WIDTH 	115

#define NUM_BUTTONS 	6		// number of buttons
#define SELECTED_COLOR  RED

/* Position of the card in the window */
#define PAGE_LLX (-GP142_XMAX + BUTTON_WIDTH +60)
#define PAGE_LLY (-GP142_YMAX + 100)
#define PAGE_WIDTH (GP142_XMAX - PAGE_LLX - 80)
#define PAGE_HEIGHT (GP142_YMAX - PAGE_LLY - 50)

// Fill graphic or line
#define FILL 0
#define NOFILL 1

/* Types of objects we support.  (Perhaps not all types are used yet.)*/
#define OBJECT_NONE 0
#define OBJECT_SHAPE 1
#define OBJECT_MESSAGE 2

// Object properties
#define MAX_OBJECTS 20		// max # of objects allowed on card 
#define MAX_SHAPES 5		// max # of shapes
#define MAX_MESSAGES 6		// max # of messages

// Shapes
#define SHAPE_HEART 0
#define SHAPE_STAR  1
#define SHAPE_GIFT  2
#define SHAPE_BEAR  3
#define SHAPE_MOON  4
// Messages
#define KISSME   0
#define GETTING  1
#define ANYTHING 2
#define PIECE 3
#define LOVIN 4
#define GUARANTEE 5

/*Possible places for mouse clicks*/
#define CLICK_BUTTON 1  /* You clicked on SOME button (doesn't say which one)*/
#define CLICK_CARD 2    /* You clicked in the card area */
#define CLICK_OUTSIDE 3	/* You clicked outside the card area, not on a button*/	


/*******************  FUNCTION PROTOTYPES **************************/
// Opening Screen
void Opener(void);
void DropButtons(int *bottom_y);

/* Drawing functions */
void DrawBlankScreen (void);
void DrawButtons(int last_button, int status);
void DrawCard (int background_color, int status, int object_count, 
			   int object_type[], int object_num[], 
			   int object_color[], int object_x[], int object_y[]);
void DrawMessage(int message_type, int color, 
				 int bottom_x, int bottom_y);
void DrawShape(int shape_type, int background_color, int color, 
			   int bottom_x, int bottom_y);
void DrawHeart (int x, int y, int color);
void DrawStar (int x, int y, int color);
void DrawGift (int x, int y, int color);
void DrawBear (int x, int y, int color);
void DrawMoon (int x, int y, int color, int background_color);

/* Mouse click handling functions */
int ClassifyMouseClick(int mouse_x, int mouse_y);
void HandleMouseClick(int mouse_x, int mouse_y, int *background_color, 
					  int *status, int *object_count, int object_type[], 
					  int object_num[], int object_color[], 
					  int object_x[], int object_y[],
					  int *current_object, int *last_button);
void HandleButton(int x, int y, int *background_color, int *status,
				  int object_count, int object_type[], int object_num[], 
				  int object_color[], int current_object, int *last_button);
/* Add a shape to the card. */
void AddShape_or_Message(int x, int y, int *status, int *object_count, 
			   int object_type[], int object_num[], int object_color[], 
			   int object_x[], int object_y[], int *current_object);
/* Reselect an object */
void Reselect(int mouse_x, int mouse_y, int *status, int object_count,
			  int *current_object, int object_x[], int object_y[]);
/*****************************************************************************
     MAIN
*****************************************************************************/
int main(void)
{
	int quit = FALSE, move_on = FALSE;              /* becomes TRUE to exit program */
	int mouse_x, mouse_y;          /* coordinates of a mouse click */
	int bottom_y;					// for opener 
	char key_hit;                  /* which key was hit            */
	
	
	/*variables and their default values*/
	int background_color = YELLOW;
	int status = STATUS_ADD_SHAPE;
	
	// Object Properties
	int object_count = 0;					// How many objects on the page? 
	int object_type[MAX_OBJECTS];			// Shape or Message?			 
	int object_num[MAX_OBJECTS];            // Which shape or message		 
	int object_color[MAX_OBJECTS];          // Color of object               
	int object_x[MAX_OBJECTS];              // Position of object            
	int object_y[MAX_OBJECTS];

	int current_object = 0;					// current selected object

	int last_button = -1;           /* Keep track of the last button clicked.
	                                   This would be usefull when highlighting
	                                   the last button the user clicked */

	int event; /*the most recent GP142 event*/
	
	time_t t; /*needed only when initializing a random number generator*/
	

	/*
	 * INITIALIZATIONS
	 */
	srand (time(&t));	   // seed random number generator	

	/* These GP142 initializations don't need to be changed */
	GP142_open();           /* Open and init the GP142 Graphics Window      */
	GP142_show_text(0);     /* Hide the text window                         */
	GP142_logging(LOG_OFF); /* Change to LOG_ON if you want it.             */
	
	GP142_clear();	        /* This will clear the window & paint it white. */
	GP142_animate(ANI_RUN); /* Enable periodic events                       */


	// Opening screen
	Opener(); 
	while (!quit) {    
		switch (GP142_await_event(&mouse_x, &mouse_y, &key_hit)) {
		case GP142_QUIT:
			quit = TRUE;        
			break;    
		case GP142_MOUSE:
			move_on = TRUE;
			break;
		}

		//if user clicks w/ mouse then move on
		if(move_on == TRUE)
			break;
	}

	move_on = FALSE;
	bottom_y = GP142_YMAX + (NUM_BUTTONS * BUTTON_HEIGHT);
	DrawBlankScreen();
	// drop menu
	while (!quit) {
		switch (GP142_await_event(&mouse_x, &mouse_y, &key_hit)) {
		case GP142_QUIT:
			quit = TRUE;        
			break;    
		case GP142_MOUSE:
			move_on = TRUE;
			break;
		case GP142_PERIODIC:
			DropButtons(&bottom_y);
			if(bottom_y <= GP142_YMAX)
				move_on = TRUE;
			break;
		}

		//if user clicks w/ mouse then move on
		if(move_on == TRUE)
			break;
	}

	
	// The main event loop:
	while (!quit) {  
		
		/*start by redrawing everything */
		DrawBlankScreen ();
		DrawCard (background_color, status, object_count, object_type, object_num, 
			object_color, object_x, object_y);
		DrawButtons(last_button, status);	  /* Show the buttons...*/ 
		
		/*Wait for something to happen */
		event = GP142_await_event(&mouse_x, &mouse_y, &key_hit);
		
		// figure out event and react
		switch (event) {
		case GP142_QUIT:
			quit = TRUE;           /* set flag to terminate loop           */
			break;
		case GP142_KBD:  /*A key was pressed */
			break;
		case GP142_MOUSE:
			// Call mouse handler
			HandleMouseClick(mouse_x, mouse_y, &background_color, &status, 
					         &object_count, object_type, 
							 object_num, object_color, 
							 object_x, object_y, &current_object, &last_button);			
			break;
		case GP142_PERIODIC:
			break;
		default:
			break;
		}  /*end switch */
	}  /* end event loop */
	
	// WRAP-UP
	GP142_close();         /* clean up and close graphics window   */
	
	return 0;
}  /*end main */

/*****************************************************************************
    FUNCTIONS
*****************************************************************************/
// Blank screen by covering it w/ white
void DrawBlankScreen (void) {
	int font_size = 14;

	GP142_rectangleXY (WHITE,
					-GP142_XMAX, -GP142_YMAX,
					GP142_XMAX, GP142_YMAX,
					FILL);

} /*end DrawBlankScreen */

//
void Opener(void){
	GP142_rectangleXY(BLACK,
		GP142_XMAX,
		-GP142_YMAX,
		-GP142_XMAX,
		GP142_YMAX, FILL);

	GP142_printfXY(RED, -180, 0, 24, "Creat-A^-Card by Ace Productions");
	GP142_printfXY(MAGENTA, -110, 25, 17, "Valentines");
	GP142_printfXY(BLUE, -GP142_XMAX+5, -GP142_YMAX+3, 12, "Click to Continue");
}

void DropButtons(int *bottom_y) {

	char b_labels [NUM_BUTTONS][25] = {
		"Background color",
			"Object color",
			"Next, please",
			"Add message",
			"Add shape",
			"Select object"			
	};
	
	int i, text_offset = -GP142_XMAX + 10, font_size = 12;
	int y, label_y;

		
	/* draw rectangles and labels for each button */
	for(i = 0; i < NUM_BUTTONS; i++) {
		y = *bottom_y - i * BUTTON_HEIGHT;
		
		GP142_rectangleXY(BLACK,
			-GP142_XMAX + 4,
			y - 3,
			-GP142_XMAX + BUTTON_WIDTH,
			y - BUTTON_HEIGHT - 3, 2);

		GP142_rectangleXY(MED_GRAY,
			-GP142_XMAX + 5, y - 4,
			-GP142_XMAX + BUTTON_WIDTH - 2,
			y - BUTTON_HEIGHT - 1, FILL);

		label_y = (y - BUTTON_HEIGHT/2) - 11;
		
		GP142_printfXY(BLACK, text_offset, label_y, font_size, b_labels[i]);	
	}

	*bottom_y = *bottom_y - 15;
}

// Draws the buttons 
void DrawButtons(int last_button, int status) {

	char b_labels [NUM_BUTTONS][25] = {
		"Background color",
			"Object color",
			"Next, please",
			"Add message",
			"Add shape",
			"Select object"			
	};

	int i, text_offset = -GP142_XMAX + 10, font_size = 12;
	int y, label_y;

	/* draw rectangles and labels for each button */
	for(i = 0; i < NUM_BUTTONS; i++) {
		y = GP142_YMAX - i * BUTTON_HEIGHT;
		
		GP142_rectangleXY(BLACK,
			-GP142_XMAX + 4,
			y - 3,
			-GP142_XMAX + BUTTON_WIDTH,
			y - BUTTON_HEIGHT - 3, 2);

		GP142_rectangleXY(MED_GRAY,
			-GP142_XMAX + 5, y - 4,
			-GP142_XMAX + BUTTON_WIDTH - 2,
			y - BUTTON_HEIGHT - 1, FILL);

		label_y = (y - BUTTON_HEIGHT/2) - 11;
		
		if (i == last_button)
		{
						
			GP142_rectangleXY(23,
				-GP142_XMAX + 5,
				y - 4,
				-GP142_XMAX + BUTTON_WIDTH - 2,
				y - BUTTON_HEIGHT - 1, FILL);

			GP142_printfXY(WHITE, text_offset, label_y, font_size, b_labels[i]);
		}	
		else
			GP142_printfXY(BLACK, text_offset, label_y, font_size, b_labels[i]);
	}
}


// Render (draw) the page and all its contents.
void DrawCard (int background_color, int status, int object_count, 
			   int object_type[], int object_num[], 
			   int object_color[], int object_x[], int object_y[]) {
	int font_size = 14;
	int i;

	// Draw the background of the card.
	GP142_rectangleXY (background_color,
		PAGE_LLX, PAGE_LLY,
		PAGE_LLX+ PAGE_WIDTH, PAGE_LLY+ PAGE_HEIGHT,
		FILL);
	
	// Draw object/s on the card, if they currently exist
	if (object_count > 0) {
		for(i = 0; i < object_count; i++) {
			// Draw message
			if(object_type[i] == OBJECT_MESSAGE)
				DrawMessage(object_num[i], object_color[i],
					object_x[i], object_y[i]);
			// Draw shape
			else
				DrawShape(object_num[i], background_color,
					object_color[i], 					
					object_x[i], object_y[i]);
		}
	}
	
	// Write an appropriate status message below the background
	switch (status) {
	case STATUS_ADD_SHAPE:
		GP142_printfXY (BLACK, PAGE_LLX, PAGE_LLY-40, font_size-3,
			"Click on the card to add a shape");
		break;
	case STATUS_SELECTED:
		GP142_printfXY (BLACK, PAGE_LLX, PAGE_LLY-40, font_size-3,
			"Object selected. Click on the card to move it, or click 'color' or 'next' button");
		break;
	case STATUS_ADD_MESSAGE:
		GP142_printfXY (BLACK, PAGE_LLX, PAGE_LLY-40, font_size-3,
			"Click on the card to add a message");
		break;
	case STATUS_SELECT_OBJECT:
		GP142_printfXY (BLACK, PAGE_LLX, PAGE_LLY-40, font_size-3,
			"Select object near its origin");
		break;
	default:
		GP142_printfXY (BLACK, PAGE_LLX, PAGE_LLY-40, font_size-3,
			"Status error -- notify programmer");
		break;
	} /*end switch */
} /*end DrawPage */


// Print one message.
void DrawMessage(int message_type, int color, int bottom_x, int bottom_y) {

	int font_size = 12;

	switch (message_type) {
	case KISSME:
		GP142_printfXY (color, bottom_x, bottom_y, font_size,
			"Kiss me...not there!");
		break;
	case GETTING:
		GP142_printfXY (color, bottom_x, bottom_y, font_size,
			"You're getting it tonight!");
		break;
	case ANYTHING:
		GP142_printfXY (color, bottom_x, bottom_y, font_size,
			"Anything for you");
		break;
	case PIECE:
		GP142_printfXY (color, bottom_x, bottom_y, font_size,
			"You can have any piece or all of this");
		break;
	case LOVIN:
		GP142_printfXY (color, bottom_x, bottom_y, font_size,
			"Do you want some lovin?");
		break;
	case GUARANTEE:
		GP142_printfXY (color, bottom_x, bottom_y, font_size,
			"This is backed by a 100 percent satisfaction guarantee");
		break;
	} /*end switch*/
}


// Draw one shape.
void DrawShape(int shape_type, int background_color,
			   int color, int bottom_x, int bottom_y) {

	switch (shape_type) {
	case SHAPE_HEART:
		DrawHeart (bottom_x, bottom_y, color);
		break;
	case SHAPE_STAR:
		DrawStar (bottom_x, bottom_y, color);
		break;
	case SHAPE_GIFT:
		DrawGift (bottom_x, bottom_y, color);
		break;
	case SHAPE_BEAR:
		DrawBear (bottom_x, bottom_y, color);
		break;
	case SHAPE_MOON:
		DrawMoon (bottom_x, bottom_y, color, background_color);
		break;
	default: // unknown shape selected
		break;
	} /*end switch*/
}

/************** Shapes and Messages  ******************/
// Draw Heart
#define HEART_WIDTH 35
void DrawHeart (int x, int y, int color) {

	int h = (HEART_WIDTH/2);

	GP142_circleXY (color, x - h + 5, y, h);
	GP142_circleXY (color, x + h - 5, y, h);
	GP142_triangleXY (color, x- h*2 +5, y-5,
						x + h*2 -5, y-5,
						x, y - h*2 -5, FILL);
}


// Draw a star  
#define STARPOINTS 5
#define STARRADIUS 40
#define PI 3.1416
void DrawStar (int x, int y, int color) {

	int sp;
	double angle;
	int x1, y1;

	sp = STARPOINTS + (rand () %3);
	for (angle = 0.0; angle < 2 * PI; angle = angle + (2*PI)/sp) {
		x1 = (int) (cos (angle) * STARRADIUS);
		y1 = (int) (sin (angle) * STARRADIUS);
		GP142_lineXY (color, x+x1, y+y1, x-x1, y-y1, 1);
	}
}


// Draw Gift on card
void DrawGift (int x, int y, int color) {

	/* Other colors */
	int other_color;
	other_color = (color + 1) % MAX_COLORS;

	// ribbon
	GP142_ovalXY (other_color, x - 14, y+13, x, y+24, 2);
	GP142_ovalXY (other_color, x + 14, y+13, x, y+24, 2);

    GP142_rectangleXY(color, x-20, y-10, x+20, y+15, FILL);		// box
    GP142_rectangleXY(other_color, x-5, y-10, x+5, y+15 , FILL);	// vertical band
}


// Draw Puffkin Bear 
void DrawBear (int x, int y, int color){
	
	/* Other colors */
	int other_color, toe_color;
	other_color = (color + 1) % MAX_COLORS;
	toe_color = (color + 3) % MAX_COLORS;

	/* Draw Ears */
	GP142_circleXY (other_color, x-15, y+17, 9);		// left ear
	GP142_circleXY (other_color, x+15, y+17, 9);		// right ear

	/* Draw Body */
	GP142_ovalXY(color, x-23, y-20,	
		         x+23,y+20,	FILL);	
	GP142_ovalXY(color, x-23, y-30,	
		         x+23,y+15, FILL);	
				
	/* Draw Feet */
	GP142_circleXY (other_color, x-13, y-20, 11);		// left foot
	GP142_lineXY(toe_color, x-13, y-14, x-13, y-9, 2);
	GP142_lineXY(toe_color, x-18, y-16, x-18, y-11, 2);
	GP142_lineXY(toe_color, x-8, y-16, x-8, y-11, 2);

	GP142_circleXY (other_color, x+13, y-20, 11);		// right foot
	GP142_lineXY(toe_color, x+13, y-14, x+13, y-9, 2);
	GP142_lineXY(toe_color, x+18, y-16, x+18, y-11, 2);
	GP142_lineXY(toe_color, x+8, y-16, x+8, y-11, 2);

	/* Draw Face */
	GP142_circleXY (other_color, x-7, y+3, 3);	// left eye
	GP142_circleXY (other_color, x+7, y+3, 3);	// right eye
	GP142_ovalXY(BLACK, x-3, y-1,				// nose
		         x+3,y-5, FILL);
}


// Draw Moon 
void DrawMoon (int x, int y, int color, int background_color) {

	// feet color
	int feet_color;
	feet_color = (color + 1) % MAX_COLORS;

	/* Feet & Legs */
	GP142_ovalXY(feet_color, x-10, y-35,	// left leg
		         x-1,y-29, FILL);
    GP142_rectangleXY(color, x-10, y, x-1, y-30 , FILL); 

	GP142_ovalXY(feet_color, x+1, y-35,	// right leg
		         x+10,y-29,	FILL);
    GP142_rectangleXY(color, x+1, y, x+10, y-30 , FILL); 

	// CHEEKS...hehe
	GP142_circleXY (color, x - 5, y, 10);
	GP142_circleXY (color, x + 5, y, 10);
	GP142_ovalXY(background_color, x-15, y-10,	
		         x+5,y+10, NOFILL);
	GP142_ovalXY(background_color, x-5, y-10,	
		         x+15,y+10, NOFILL);
	GP142_circleXY (color, x - 5, y, 9);
	GP142_circleXY (color, x + 5, y, 9);

	// CRACK...haha
	GP142_lineXY(background_color, x, y-4, x, y-10, 1);
}

/********************* Mouse Handling *********************/
//  Determine where mouse click was: button, card, or outside
int ClassifyMouseClick(int mouse_x, int mouse_y) {
  if ((mouse_x < -GP142_XMAX + BUTTON_WIDTH) &&
      (mouse_y < GP142_YMAX) &&
      (mouse_y > (GP142_YMAX - NUM_BUTTONS*BUTTON_HEIGHT)))
    return CLICK_BUTTON;
  else if (mouse_x >= PAGE_LLX && mouse_x < PAGE_LLX + PAGE_WIDTH
	  && mouse_y >= PAGE_LLY && mouse_y < PAGE_LLY + PAGE_HEIGHT)
    return CLICK_CARD;
  else
    return CLICK_OUTSIDE;
}


// Decide where a mouse click occured, and react appropriately.
void HandleMouseClick(int mouse_x, int mouse_y, int *background_color, 
					  int *status, int *object_count, int object_type[], 
					  int object_num[], int object_color[], 
					  int object_x[], int object_y[], 
					  int *current_object, int *last_button)
{
	int mouse_click;
	mouse_click = ClassifyMouseClick(mouse_x, mouse_y);
			
	if (mouse_click == CLICK_BUTTON) {
				
		// A button has been clicked.  Call a function to handle it
		// most of the variables passed as args will NOT change
		// Status changes if certain button is clicked
		HandleButton(mouse_x, mouse_y, background_color, status, 
					 *object_count, object_type,object_num, 
					 object_color, *current_object, last_button);

	} else if (mouse_click == CLICK_CARD) {
		/* Add a shape, if there isn't one already */
		if ((*object_count == 0) && ((*status == STATUS_ADD_SHAPE) || (*status == STATUS_ADD_MESSAGE))){	
		AddShape_or_Message(mouse_x, mouse_y, status, object_count,			
			   object_type, object_num, object_color,				
			   object_x, object_y, current_object);}									
		else
			// If user wants to select an existing object
			if (*status == STATUS_SELECT_OBJECT){
				Reselect(mouse_x, mouse_y, status, *object_count,
					current_object, object_x, object_y);}
			else
				// Add shape if user clicked on button to
				if((*status == STATUS_ADD_SHAPE) || (*status == STATUS_ADD_MESSAGE))
					AddShape_or_Message(mouse_x, mouse_y, status, object_count,			
						object_type, object_num, object_color,				
						object_x, object_y, current_object);
				// Else move current object
				else
					if(*status == STATUS_SELECTED) {
						object_x[*current_object] = mouse_x;
						object_y[*current_object] = mouse_y; }
	}								
	/* Ignore any other mouse clicks */
}


// Figure out which button was clicked, if any, and do the right thing
void HandleButton(int x, int y, int *background_color, int *status,
				  int object_count, int object_type[], int object_num[], 
				  int object_color[], int current_object, int *last_button)
{
	int buttonNum = 0;
	
	// if outside area, we could not have clicked on a button
	if (x > -GP142_XMAX + BUTTON_WIDTH)  
		return ;	/*That's an error situation*/
	
	// calculate which button clicked
	buttonNum = (GP142_YMAX - y)/BUTTON_HEIGHT;	 
	
	switch(buttonNum) {
	case 0:
		/* Change the background color */
		*background_color = (*background_color + 1) % MAX_COLORS;
		*last_button = 0;
		break;
	case 1:
		/* Change the object color */
		object_color[current_object] = (object_color[current_object] + 1) % MAX_COLORS;
		*last_button = 1;
		break;
	case 2:
		/* Next */
		*last_button = 2;
		if (*status == STATUS_SELECTED) {
			// determine if object or message to properly change
			if(object_type[current_object] == OBJECT_MESSAGE)
				object_num[current_object] = (object_num[current_object] + 1) % MAX_MESSAGES;
			else
				object_num[current_object] = (object_num[current_object] + 1) % MAX_SHAPES; }
		break;
	case 3:
		/* Add message */
		*status = STATUS_ADD_MESSAGE;
		*last_button = 3;
		break;
	case 4:
		/* Add shape */
		*status = STATUS_ADD_SHAPE;
		*last_button = 4;
		break;
	case 5:
		/* Select object if there are any */
		*last_button = 5;
		if(object_count > 0)
			*status = STATUS_SELECT_OBJECT;
		break;
	default:		//Bad news if this is ever reached!
		*status = 999;
		break;
	}
}


/* If there's room for another shape, add it to the card. */
void AddShape_or_Message(int x, int y, int *status, int *object_count, 
			   int object_type[], int object_num[], int object_color[], 
			   int object_x[], int object_y[], int *current_object) {

	//  Limit number of objects on card to 20
	if ((*object_count >= 0) && (*object_count <= MAX_OBJECTS)) {
		/*  If user wants to add a shape  */
		if (*status == STATUS_ADD_SHAPE) {	
		
			*status = STATUS_SELECTED;					// change status to selected
						
			object_type[*object_count] = OBJECT_SHAPE;
			object_num[*object_count] = SHAPE_HEART;
			object_color[*object_count] = RED;
			object_x[*object_count] = x;
			object_y[*object_count] = y;
			
			*object_count = *object_count + 1;			// increase object count
			*current_object = *object_count - 1;		// set current object
		}
		/*  Else he wants a message  */
		else {
			*status = STATUS_SELECTED;					// change status to selected

			object_type[*object_count] = OBJECT_MESSAGE;
			object_num[*object_count] = ANYTHING;
			object_color[*object_count] = RED;
			object_x[*object_count] = x;
			object_y[*object_count] = y;
			
			*object_count = *object_count + 1;			// increase object count
			*current_object = *object_count - 1;		// set current object
		}
	}
}


//  Reselect an object if mouse click is near  
void Reselect(int mouse_x, int mouse_y, int *status, int object_count,
			  int *current_object, int object_x[], int object_y[]) {
	int i;
	
	// Check to see if click is near an object
	for (i = 0; i < object_count; i++)
		if ((object_x[i] >= mouse_x - 3) && (object_x[i] <= mouse_x + 3) &&
			(object_y[i] >= mouse_y - 3) && (object_y[i] <= mouse_y + 3))  {

			*status = STATUS_SELECTED;		// change status to selected
			*current_object = i;			// set current object
			break;							// break out of loop once object is selected
		}
}